## scm 5e5

=== Makefile ===
# "Makefile" for scm Scheme Interpreter
# Copyright (C) 1990-2008 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this program.  If not, see
# <http://www.gnu.org/licenses/>.

# Author: Aubrey Jaffer

SHELL = /bin/sh
#CC = gcc
#CFLAGS = -g
#LIBS =
#LD = $(CC) -g
LD = $(CC)
SCMLIT = ./scmlit
SCMEXE = ./scm
#SHOBJS = *.sl
SHOBJS = *.so

#BUILD = ./build -hsystem -p svr4-gcc-sun-ld
BUILD = ./build -hsystem

# Workaround for unexec on Fedora Core 1 GNU/Linux i386
#SETARCH = setarch i386

# http://jamesthornton.com/writing/emacs-compile.html
# [For FC3] combreloc has become the default for recent GNU ld, which
# breaks the unexec/undump on all versions of both Emacs and
# XEmacs...
#
# Add the following to udscm5.opt:
#--linker-options="-z nocombreloc"

# http://www.opensubscriber.com/message/emacs-devel@gnu.org/1007118.html
# Kernels later than 2.6.11 must do (as root) before dumping:
#echo 0 > /proc/sys/kernel/randomize_va_space

#for RPMs
RELEASE = 1

intro:
	@echo
	@echo "This is the scm-$(VERSION) distribution.  Read \"scm.info\""
	@echo "to learn how to build and install SCM.  Or browse"
	@echo "      http://swiss.csail.mit.edu/~jaffer/SCM"
	@echo
	$(MAKE) scm

srcdir.mk:	Makefile
	echo "CPROTO=`type cproto | sed 's%.* %%'`" > srcdir.mk
	echo "srcdir=`pwd`/" >> srcdir.mk
#srcdir=$(HOME)/scm/
#srcdir=/usr/local/src/scm/
include srcdir.mk

# directory where COPYING and InitXXX.scm reside.
#IMPLPATH = /usr/local/src/scm/
#this one is good for bootstrapping
#IMPLPATH = `pwd`/
IMPLPATH=$(srcdir)
include patchlvl.h
IMPLINIT = $(IMPLPATH)Init$(VERSION).scm

# If pathname where InitXXX.scm resides is not known in advance then
# SCM_INIT_PATH is the environment variable whose value is the
# pathname where InitXXX.scm resides.

hfiles = scm.h scmfig.h setjump.h patchlvl.h continue.h
cfiles = scmmain.c scm.c time.c repl.c ioext.c scl.c sys.c eval.c	\
	subr.c sc2.c unif.c rgx.c crs.c dynl.c record.c posix.c socket.c\
	unix.c rope.c ramap.c gsubr.c edline.c continue.c	\
	findexec.c script.c debug.c byte.c bytenumb.c differ.c
ufiles = pre-crt0.c ecrt0.c gmalloc.c unexec.c unexelf.c unexhp9k800.c \
	unexsunos4.c unexalpha.c unexsgi.c
#	cxux-crt0.s ecrt0.c gmalloc.c pre-crt0.c unexaix.c unexalpha.c \
#	unexapollo.c unexconvex.c unexec.c unexelf.c unexelf1.c \
#	unexencap.c unexenix.c unexfx2800.c unexhp9k800.c unexmips.c \
#	unexnext.c unexnt.c unexsgi.c unexsni.c unexsunos4.c
ofiles = scm.o time.o repl.o scl.o sys.o eval.o subr.o unif.o rope.o \
	continue.o findexec.o script.o debug.o
# continue-ia64.o
ifiles = Init$(VERSION).scm Transcen.scm Link.scm Macro.scm Macexp.scm \
	Tscript.scm compile.scm Iedline.scm Idiffer.scm
hobfiles = hobbit.scm scmhob.scm scmhob.h
turfiles = turtlegr.c turtle grtest.scm
xafiles = xatoms.scm x11.scm xevent.scm keysymdef.scm
xfiles = x.c x.h xgen.scm xevent.h inc2scm $(xafiles)

all:	require.scm
	$(MAKE) mydlls
	$(MAKE) dscm5
	$(MAKE) differ.so
	$(MAKE) db.so
	if [ -d /usr/X11R6/lib ]; then $(MAKE) x.so; fi
require.scm:
	cp -p requires.scm require.scm

# SCMLIT -- try making this first!
scmlit:	$(ofiles) scmmain.o require.scm Makefile
	$(LD) -o scmlit $(ofiles) scmmain.o $(LIBS)
	$(MAKE) checklit
scmflags.h:	scmflags
scmflags:
	echo "#ifndef IMPLINIT" > newflags.h
	echo "#define IMPLINIT \"$(IMPLINIT)\"" >> newflags.h
	echo "#endif" >> newflags.h
	echo "#define CHEAP_CONTINUATIONS" >> newflags.h
	echo "#define CAUTIOUS" >> newflags.h
	-if (cmp -s newflags.h scmflags.h) then rm newflags.h; \
		 else mv newflags.h scmflags.h; fi
.c.o:
	$(CC) -c $(CFLAGS) $< -o $@
scm.o:	scm.c scm.h scmfig.h scmflags.h patchlvl.h
scmmain.o:	scmmain.c scm.h scmfig.h scmflags.h patchlvl.h
scl.o:	scl.c scm.h scmfig.h scmflags.h
eval.o:	eval.c scm.h scmfig.h scmflags.h setjump.h
debug.o: debug.c scm.h scmfig.h scmflags.h setjump.h
unif.o:	unif.c scm.h scmfig.h scmflags.h
#ramap.o:	ramap.c scm.h scmfig.h scmflags.h
repl.o:	repl.c scm.h scmfig.h scmflags.h setjump.h
sys.o:	sys.c scm.h scmfig.h scmflags.h setjump.h
time.o:	time.c scm.h scmfig.h scmflags.h
subr.o:	subr.c scm.h scmfig.h scmflags.h
rope.o:	rope.c scm.h scmfig.h scmflags.h
continue.o: continue.c continue.h setjump.h scm.h scmfig.h scmflags.h
continue-ia64.o: continue-ia64.S get-contoffset-ia64.c
	gcc -o get-contoffset-ia64 get-contoffset-ia64.c
	./get-contoffset-ia64 contoffset-ia64.S
	gcc -c -o continue-ia64.o continue-ia64.S

# Simple build with bignums for running JACAL
scm:	scmlit
	$(BUILD) -s $(IMPLPATH) -F cautious bignums arrays # i/o-extensions
	$(MAKE) check

# R4RS interpreter (not dumpable)
scm4.opt:
	echo "-F cautious bignums arrays inexact" >> scm4.opt
	echo "-F engineering-notation dynamic-linking" >> scm4.opt
#	if type gcc; then echo "--compiler-options=\"-fno-guess-branch-probability\"" >> scm4.opt; fi
scm4:	$(cfiles) $(hfiles) build.scm build scm4.opt
	$(BUILD) -f scm4.opt -o scm -s $(IMPLPATH)
	-rm $(ofiles) scmmain.o
	-$(MAKE) check

# R5RS interpreter (not dumpable)
scm5.opt:
	echo "-F cautious bignums arrays inexact" >> scm5.opt
	echo "-F engineering-notation dynamic-linking" >> scm5.opt
	echo "-F macro" >> scm5.opt
#	if type gcc; then echo "--compiler-options=\"-fno-guess-branch-probability\"" >> scm5.opt; fi
scm5:	$(cfiles) $(hfiles) build.scm build scm5.opt
	$(BUILD) -f scm5.opt -o scm -s $(IMPLPATH)
	-rm $(ofiles) scmmain.o
	-$(MAKE) check
	-$(MAKE) checkmacro

# dumpable R4RS interpreter
udscm4.opt:
	echo "-F cautious bignums arrays inexact" >> udscm4.opt
	echo "-F engineering-notation dump dynamic-linking" >> udscm4.opt
#	if type gcc; then echo "--compiler-options=\"-fno-guess-branch-probability\"" >> udscm4.opt; fi
udscm4:	$(cfiles) $(hfiles) build.scm build udscm4.opt
	$(BUILD) -f udscm4.opt -o udscm4 -s $(IMPLPATH)
	-rm $(ofiles) scmmain.o
dscm4:	udscm4 $(ifiles) require.scm
	if [ -f /proc/sys/kernel/randomize_va_space -a\
	     "`cat /proc/sys/kernel/randomize_va_space`" != "0" ]; then {\
	   cat /proc/sys/kernel/randomize_va_space > randomize_va_space.tmp;\
	   echo 0 > /proc/sys/kernel/randomize_va_space;\
	} fi
	-rm -f slibcat implcat scm~
	-mv scm scm~
	echo "(quit)" | $(SETARCH) ./udscm4 -no-init-file -o scm
	if [ -f randomize_va_space.tmp ]; then {\
	   cat randomize_va_space.tmp > /proc/sys/kernel/randomize_va_space;\
	   rm randomize_va_space.tmp;\
	} fi

# dumpable R5RS interpreter
udscm5.opt:
	$(MAKE) udscm4.opt
	cat udscm4.opt >> udscm5.opt
	echo "-F macro" >> udscm5.opt
udscm5:	$(cfiles) $(ufiles) $(hfiles) build.scm build udscm5.opt
	$(BUILD) -f udscm5.opt -o udscm5 -s $(IMPLPATH)
	-rm $(ofiles) scmmain.o
	strip udscm5
dscm5:	udscm5 $(ifiles) require.scm
	if [ -f /proc/sys/kernel/randomize_va_space -a\
	     "`cat /proc/sys/kernel/randomize_va_space`" != "0" ]; then {\
	   cat /proc/sys/kernel/randomize_va_space > randomize_va_space.tmp;\
	   echo 0 > /proc/sys/kernel/randomize_va_space;\
	} fi
	-rm -f slibcat implcat scm~
	-mv scm scm~
	echo "(quit)" | $(SETARCH) ./udscm5 -no-init-file -r5 -o scm
	if [ -f randomize_va_space.tmp ]; then {\
	   cat randomize_va_space.tmp > /proc/sys/kernel/randomize_va_space;\
	   rm randomize_va_space.tmp;\
	} fi
	$(MAKE) check
	$(MAKE) checkmacro

# R5RS interpreter for debugging with GDB.
gdb.opt: udscm5.opt
	cat udscm5.opt > gdb.opt
	echo "-F debug" >> gdb.opt
	echo "--compiler-options=-Wall" >> gdb.opt
	echo "--linker-options=-Wall" >> gdb.opt
	echo "-D NO_ENV_CACHE" >> gdb.opt
#	echo "-DTEST_FARLOC -DTEST_SCM2PTR" >> gdb.opt
udgdbscm: gdb.opt $(cfiles) $(ufiles) $(hfiles) build.scm build
	$(BUILD) -f gdb.opt -o udgdbscm -s $(IMPLPATH)
gdbscm: udgdbscm $(ifiles) require.scm
	echo "(quit)" | $(SETARCH) ./udgdbscm -no-init-file -r5 -o gdbscm

# R4RS interpreter for profiling
pg.opt: udscm4.opt
	cat udscm4.opt >> pg.opt
	echo "--compiler-options=-pg" >> pg.opt
	echo "--linker-options=-pg" >> pg.opt
	echo "-DLACK_SETITIMER" >> pg.opt
udpgscm: pg.opt
	$(BUILD) -f pg.opt -o udpgscm -s $(IMPLPATH)
pgscm:  udpgscm
	echo "(quit)" | $(SETARCH) ./udpgscm -no-init-file -o pgscm

# R4RS SCM library
libscm.opt:
	echo "-F cautious bignums arrays inexact" >> libscm.opt
	echo "-F engineering-notation" >> libscm.opt
	echo "-F dynamic-linking" >> libscm.opt
mylib:	libscm.a
libscm.a:	libscm.opt scm.h scmfig.h
	$(BUILD) -t lib -f libscm.opt
libtest:	libscm.a libtest.c
	$(LD) -o libtest libtest.c libscm.a -ldl -lm -lc
	./libtest

# DLLs for dynamic linking
dlls.opt:
	echo "--compiler-options=-Wall" >> dlls.opt
	echo "--linker-options=-Wall" >> dlls.opt
mydlls:	dlls.opt bytenumb.so
	$(BUILD) -t dll -f dlls.opt -c ramap.c
	$(BUILD) -t dll -f dlls.opt -c record.c
	$(BUILD) -t dll -f dlls.opt -c gsubr.c
	$(BUILD) -t dll -f dlls.opt -c byte.c
	$(BUILD) -t dll -f dlls.opt -c sc2.c
	$(BUILD) -t dll -f dlls.opt -c ioext.c
	$(BUILD) -t dll -f dlls.opt -c posix.c
	$(BUILD) -t dll -f dlls.opt -c socket.c
	$(BUILD) -t dll -f dlls.opt -c unix.c
	$(BUILD) -t dll -f dlls.opt -F curses
	$(BUILD) -t dll -f dlls.opt -c rgx.c
	if [ -f /usr/lib/libreadline.so ]; \
		then $(BUILD) -t dll -f dlls.opt -F edit-line; fi

rwb-isam.scm wbtab.scm: ../wb/rwb-isam.scm ../wb/wbtab.scm
	cp ../wb/rwb-isam.scm ../wb/wbtab.scm ./
db.so: dlls.opt rwb-isam.scm wbtab.scm scm.h scmfig.h
	if [ -f ../wb/blink.c ]; then \
		$(BUILD) -t dll -f dlls.opt -F wb; fi

bytenumb.so:	bytenumb.c scm.h scmfig.h
	$(BUILD) -t dll -f dlls.opt -F byte-number inexact bignums
differ.so:		differ.c scm.h scmfig.h
	$(BUILD) -t dll -f dlls.opt -F differ
myturtle:	dlls.opt scm.h scmfig.h
	$(BUILD) -t dll -f dlls.opt -F turtlegr

x.so:	x.c x.h xevent.h dlls.opt scm.h scmfig.h
	$(BUILD) -t dll -f dlls.opt -F x

# Generate x11 include and Scheme files
incdir=/usr/include/
x11.scm:	inc2scm
	rm -f x11.scm
	$(SCMLIT) -l inc2scm x11.scm x: $(DESTDIR)$(incdir) X11/X.h X11/cursorfont.h X11/Xlib.h \
	 X11/Xutil.h
keysymdef.scm:	inc2scm
	rm -f keysymdef.scm
	$(SCMLIT) -l inc2scm keysymdef.scm x: $(DESTDIR)$(incdir) X11/keysym.h X11/keysymdef.h
xevent.h xevent.scm xatoms.scm:	xgen.scm Makefile
	$(SCMLIT) -l xgen.scm $(DESTDIR)$(incdir)X11/Xlib.h
x.h:	x.c xevent.h
	if [ -x "$(CPROTO)" ]; then $(CPROTO) x.c > x.h; fi

# Check SCM; SCMLIT function.
checklit:
	$(SCMLIT) -fr4rstest.scm -e'(test-sc4)(test-delay)(gc)' \
	-e '(or (null? errs) (quit 1))'
Checklit:
	$(SCMLIT) --no-symbol-case-fold -fr4rstest.scm -e'(test-sc4)(test-delay)(gc)' \
	-e '(or (null? errs) (quit 1))'
check:	r4rstest.scm
	$(SCMEXE) -fr4rstest.scm -e'(test-sc4)(test-cont)(test-delay)(gc)' \
	-e '(or (null? errs) (quit 1))'
Check:	r4rstest.scm
	$(SCMEXE) --no-symbol-case-fold -fr4rstest.scm -e'(test-sc4)(test-cont)(test-delay)(gc)' \
	-e '(or (null? errs) (quit 1))'
checkmacro: syntest1.scm syntest2.scm r4rstest.scm
	$(SCMEXE) -rmacro -fsyntest1.scm -fsyntest2.scm \
	 -fr4rstest.scm -e'(test-sc4)(test-cont)(test-delay)' -fsyntest1 \
	-e '(or (null? errs) (quit 1))'

# Measuare running speed of SCM; SCMLIT.  Results are appended to file
# "BenchLog"
bench:
	echo `whoami`@`hostname` testing scm \
	 `$(SCMEXE) -e'(display *scm-version*)'` >> BenchLog
	echo  on `date` >> BenchLog
	ls -l scm >> BenchLog
	size scm >> BenchLog
	uname -a >> BenchLog
	$(SCMEXE) -lbench.scm
	-cat prng.log >> BenchLog
	echo >> BenchLog
	-cat pi.log >> BenchLog
	echo >> BenchLog
	echo
	tail -20 BenchLog
	-rm -f pi.log prng.log
benchlit:
	echo `whoami`@`hostname` testing scmlit \
	 `$(SCMLIT) -e'(display *scm-version*)'` >> BenchLog
	echo  on `date` >> BenchLog
	ls -l scmlit >> BenchLog
	size scmlit >> BenchLog

=== debian/changelog ===
scm (5e5-4) unstable; urgency=medium

  * New maintainer (Closes: #721061).
  * Repackage with dh.
  * man-page chapter fix.
  * Lintian fixups, including relative path references.
  * Switch from texi2html to makeinfo for manual build.
  * Switch to arch 'any'.
  * Remove build flag ("-F inexact") so that test suite passes.
  * Added #define SHORT_INT for ppc64 in scmfig.h (Closes: #476807).

 -- Bryan Newbold <bnewbold@robocracy.org>  Mon, 31 Jul 2017 23:46:47 -0700

scm (5e5-3.3) unstable; urgency=low

  * Non-maintainer upload.
  * Fixed texinfo errors (Closes: #712339)
  * Removed install-info from maintainer scripts (Closes: #708498)

 -- Hilko Bengen <bengen@debian.org>  Sat, 23 Nov 2013 15:14:04 +0100

scm (5e5-3.2) unstable; urgency=low

  * NMU, added armhf in arch list. (Closes: #604537)

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 24 Feb 2011 15:44:36 +0000

scm (5e5-3.1) unstable; urgency=low

  * Non-maintainer upload.
    ACKed by maintainer. 
  * Update debian/control.
    - Add support sh4, kfreebsd-amd64 and kfreebsd-i386.
      (Closes: #558213, #559017)
    - Replacing libreadline5-dev build dependency with libreadline-dev.
      (Closes: #553847)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 01 Mar 2010 14:58:29 +0900

scm (5e5-3) unstable; urgency=low

  * build.scm (build-continue-ia64): New function, to encapsulate the method
  for building continue-ia64.o.
  (link-c-program/linux-ia64): Use build-continue-ia64.
  (make-archive/linux-ia64): New command, to use build-continue-ia64.
  (Closes: #483273).
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Sat, 26 Jul 2008 12:08:17 -0700

scm (5e5-2) unstable; urgency=low

  * continue.h: actually make the change mentioned in 5e5-1.
  * Makefile: Likewise.
  * xgen.scm: Likewise.
  * scm.1: Likewise.
  * build.scm: Likewise.

 -- Thomas Bushnell, BSG <tb@debian.org>  Mon, 18 Feb 2008 15:37:29 -0500

scm (5e5-1) unstable; urgency=low

  * New upstream release.
  * continue.h: Repeat change from 5e1-2.
  * xgen.scm: Repeat change from 5e2-4.
  * scm.1: Repeat change from 5e2-4.
  * build.scm: Repeat change from 5e3-5.
  * Makefile: Repeat change from 5e3-2.
  * debian/control (Build-Depends): Require at least version 3b1 of slib.
  (scm Depends): Likewise.
  (libscm-dev Depends): Likewise.
    
  * Makefile (scm.info): Add explicit dependency on features.txi and
    platform.txi.  For some reason the one through $(texifiles) is 
    failing mysteriously.  Perhaps this is a make bug.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Mon, 04 Feb 2008 20:53:13 -0500

scm (5e4-5) unstable; urgency=low

  * debian/control (libscm-dev/Description): Drop mistaken extra spaces
    in description.
  
  * debian/control (libscm-dev/Depends): Use $(binary:Version} for the
    dependency rather than ${source:Version}.
  
  * debian/control (Standards-Version): Update to 3.7.3.  (No changes needed.)

 -- Thomas Bushnell, BSG <tb@debian.org>  Wed, 16 Jan 2008 16:08:07 -0500

scm (5e4-4) unstable; urgency=low

  * continue.h: Fix spelling of STACK_GROWS_UP in change from 5e4-1.
  
  * Makefile: Repeat change from 5e3-2.

 -- Thomas Bushnell, BSG <tb@debian.org>  Sun, 13 Jan 2008 22:15:05 -0500

scm (5e4-3) unstable; urgency=low

  * debian/rules (SCM_OPTIONS): Add -F differ. 
  
  * debian/control (libscm-dev): New package.  We don't make a shared library
    because there is no standardization of SCM options, and no way to indicate
    in a non-brittle fashion what SCM options are available in any particular
    build, nor any standardization of sonames.
  * debian/rules (build): Build libscm.a too.
    (install): Install libscm.a, scm.h, scmfig.h, and scmflags.h into
    libscm-dev. Don't install header files in scm package.
    (Closes: #459828)
  
  * debian/copyright: Add proper authorship and copyright information; make
    mention of the special library linking exception since we are now
    packaging the library.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Wed, 09 Jan 2008 14:08:12 -0500

scm (5e4-2) unstable; urgency=low

  * Properly acknowledge NMU 5e3-6.1.  (Closes: #369576, #458284).

 -- Thomas Bushnell, BSG <tb@debian.org>  Sun, 30 Dec 2007 17:10:06 -0800

scm (5e4-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Require at least version 3a5 of slib.
  
  * debian/postrm: New file to remove /usr/lib/scm/implcat and
    /usr/lib/scm/slibcat upon purge.  (Closes: #455124).  Thanks to Kumar
    Appaiah for the fix.
  
  * debian/control (Architecture): Add armel and armeb. (Closes: #408792).
  
  * debian/rules (install): Don't use -s when installing.  dh_strip should
    be sufficient, and this should make the nostrip build option work.
    (Closes: #438004).

  * continue.h: Repeat change from 5e1-2.
  
  * xgen.scm: Repeat change from 5e2-4.
  
  * scm.1: Repeat change from 5e2-4.
  
  * build.scm: Repeat change from 5e3-5.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Fri, 28 Dec 2007 15:56:00 -0800

scm (5e3-6.1) unstable; urgency=low

  * Non-maintainer upload. 
  * Split doc-base file into two files, add missing 'Index' fields for 'info'
    sections (closes: #369576).
    Thanks to Robert Luberda for the patch.
  * Remove from rules/postinst/postrm any manually doc-base handling code,
    since dh_installdocs supports doc-base on its own.
    Thanks to Robert Luberda for the patch.

 -- Neil Williams <codehelp@debian.org>  Sun, 15 Jul 2007 21:14:17 +0100

scm (5e3-6) unstable; urgency=medium
  
  * Medium urgency because this is a release critical issue, 
    and is part of the fix made in slib 3a4-4.

  * debian/control (scm): Add version specification to the slib
    dependency (>> 3a4).

 -- Thomas Bushnell, BSG <tb@debian.org>  Wed,  8 Nov 2006 00:12:38 -0800

scm (5e3-5) unstable; urgency=low

  * build.scm (build: C-libraries): Duplicate linux section for linux-ia64.

 -- Thomas Bushnell, BSG <tb@debian.org>  Sat, 28 Oct 2006 02:27:38 -0700

scm (5e3-4) unstable; urgency=low



=== debian/control ===
Source: scm
Section: interpreters
Priority: optional
Maintainer: Bryan Newbold <bnewbold@robocracy.org>
Build-Depends: slib (>> 3b1), libncurses5-dev, libreadline-dev, texinfo, libx11-dev, debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: http://people.csail.mit.edu/jaffer/SCM.html

Package: scm
Architecture: any
Depends: slib (>> 3b1), ${shlibs:Depends}, ${misc:Depends}
Description: Scheme language interpreter
 SCM conforms to the R5RS (Revised^5 Report on the Algorithmic Language Scheme)
 and IEEE P1178 specifications, and is portable across many architectures and
 operating systems. It additionally includes a set of popular Common Lisp
 functions, POSIX and X Windows integration, and the Hobbit scheme-to-C
 compiler.

Package: libscm-dev
Architecture: any
Section: libdevel
Depends: scm (= ${binary:Version}), slib (>> 3b1), ${misc:Depends}
Description: Embeddable library for SCM Scheme language interpreter
 This is a static library which provides the functionality of SCM, making it
 convenient add scheme functionality to other programs.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_testdir:
	dh_testdir
	test -e /usr/share/slib || \
		(echo "Must have slib installed for compile" && exit 1)

override_dh_auto_configure:
	dh_auto_configure
	cp debian/require.scm.debian require.scm
	cp debian/scm.opt.debian libscm.opt

override_dh_auto_build:
	make scmlit
	# Use the same options for both static library and executable
	./build -p linux -hsystem -f libscm.opt
	./build -p linux -hsystem -f libscm.opt -t lib
	makeinfo --html --no-split scm.texi
	makeinfo --html --no-split Xlibscm.texi
	cp XlibScm.html Xlibscm.html
	cp ChangeLog changelog

override_dh_auto_test:
	# skip: inexact tests fail; fixed in later upstream version

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_install:
	# skip; files listed explicitly

## scm 5f2

=== debian/changelog ===
scm (5f2-2build2) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 20:04:03 +0000

scm (5f2-2build1) cosmic; urgency=medium

  * No-change rebuild for ncurses soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 03 May 2018 14:19:02 +0000

scm (5f2-2) unstable; urgency=medium

  * Cherry-pick Jakub Bogusz's upstream patch to fix a 32-bit platform bignum
    bug causing test failures and FTBFS (Closes: #874112)

 -- Bryan Newbold <bnewbold@robocracy.org>  Thu, 12 Oct 2017 21:01:09 -0700

scm (5f2-1) unstable; urgency=medium

  * New upstream release (Closes: #791958) with improved floating point
    performance and many fixes over the years.
  * Automated tests now run correctly (inexact fixed upstream).
  * Fix build on ARM64 (Closes: #791959). Thanks to Martin Michlmayr!
  * Copyright file clarifications, including new upstream mix of GPL-3+ and
    LGPL-3+; fixing author typo; documentation under GFDL; some files removed
    upstream.
  * Update Debian Standards-Version to 4.0.0.
  * Fix build in hurd-i386 (Closes: #768486). Thanks to Svante Signell!

 -- Bryan Newbold <bnewbold@robocracy.org>  Tue, 01 Aug 2017 21:48:28 -0700

=== debian/control ===
Source: scm
Section: interpreters
Priority: optional
Maintainer: Bryan Newbold <bnewbold@robocracy.org>
Build-Depends: slib (>> 3b1), libncurses5-dev, libreadline-dev, texinfo, libx11-dev, debhelper (>= 9)
Standards-Version: 4.0.0
Homepage: http://people.csail.mit.edu/jaffer/SCM.html
Vcs-Git: https://git.bnewbold.net/debian/scm

Package: scm
Architecture: any
Depends: slib (>> 3b1), ${shlibs:Depends}, ${misc:Depends}
Suggests: r5rs-doc
Description: Scheme language interpreter
 SCM conforms to the R5RS (Revised^5 Report on the Algorithmic Language Scheme)
 and IEEE P1178 specifications, and is portable across many architectures and
 operating systems. It additionally includes a set of popular Common Lisp
 functions, POSIX and X Windows integration, and the Hobbit scheme-to-C
 compiler.

Package: libscm-dev
Architecture: any
Section: libdevel
Depends: scm (= ${binary:Version}), slib (>> 3b1), ${misc:Depends}
Suggests: r5rs-doc
Description: Embeddable library for SCM Scheme language interpreter
 Compact static library containing the SCM interpreter and an API making it
 easy to integrate into other programs as a scripting language.

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 		(echo "Must have slib installed for compile" && exit 1)
 
 override_dh_auto_configure:
-	dh_auto_configure
+	./configure
 	cp debian/require.scm.debian require.scm
 	cp debian/scm.opt.debian libscm.opt
 
@@ -36,11 +36,12 @@
 	cp XlibScm.html Xlibscm.html
 	cp ChangeLog changelog
 
-override_dh_auto_test:
-	# skip: inexact tests fail; fixed in later upstream version
-
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_install:
+	# Make .scm scheme library scripts non-executable...
+	chmod a-x *.scm *.c
+	# except compile.scm
+	chmod a+x compile.scm
 	# skip; files listed explicitly

## scm 5f3

=== debian/changelog ===
scm (5f3-1) unstable; urgency=medium

  * Update debian/watch uscan support file
  * New upstream version
    - removed upstream: rwb-isam.scm wbtab.scm
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Bump debhelper from deprecated 9 to 13
  * Remove listed license files (COPYING fdl.texi) from copyright.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Forward port patches; bigrecy_32bit_upstream has been upstreamed
  * Rules-Requires-Root: no
  * Remove ancient /usr/doc/scm/ business from prerm
  * Quote "Thomas Bushnell, BSG" in debian/changelog to placate lintian
  * Make debian/* stanza in debian/copyright less finicky
  * Include quilt patches for readline bug, and more! (closes: #831017)
  * Team Maintain

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 02 Dec 2021 16:31:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,19 @@
 Source: scm
 Section: interpreters
 Priority: optional
-Maintainer: Bryan Newbold <bnewbold@robocracy.org>
-Build-Depends: slib (>> 3b1), libncurses5-dev, libreadline-dev, texinfo, libx11-dev, debhelper (>= 9)
-Standards-Version: 4.0.0
-Homepage: http://people.csail.mit.edu/jaffer/SCM.html
-Vcs-Git: https://git.bnewbold.net/debian/scm
+Maintainer: Debian Scheme Dream Team <debian-scheme@lists.debian.org>
+Uploaders: Bryan Newbold <bnewbold@robocracy.org>,
+	   Barak A. Pearlmutter <bap@debian.org>
+Build-Depends: debhelper-compat (= 13),
+		slib (>> 3b1),
+		libncurses5-dev, libreadline-dev,
+		texinfo,
+		libx11-dev,
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
+Homepage: https://people.csail.mit.edu/jaffer/SCM.html
+Vcs-Git: https://salsa.debian.org/scheme-team/scm.git
+Vcs-Browser: https://salsa.debian.org/scheme-team/scm
 
 Package: scm
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,6 @@
 # package maintainers to append CFLAGS
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
 	dh $@

## scm 5f4

=== Makefile ===
# "Makefile" for scm Scheme Interpreter
# Copyright (C) 1990-2008, 2010 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this program.  If not, see
# <http://www.gnu.org/licenses/>.

# Author: Aubrey Jaffer

# These are normally set in "config.status"; defaults are here so that
# "make" won't complain about target redefinitions.
snapdir=$(HOME)/pub/
infodir=$(HOME)/info/
htmldir=$(HOME)/public_html/

SHELL = /bin/sh
INSTALL = install
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_INFO = ginstall-info

# For Windows (or at least MSYS2), set EXE=".exe" and BAT=".bat" in the environment
SCMLIT = ./scmlit$(EXE)
SCMEXE = ./scm$(EXE)
BUILD = ./build$(BAT) -hsystem

TEXI2HTML = /usr/local/bin/texi2html -split -verbose
TEXI2PDF = texi2pdf
VIEWPDF = evince
MAKEDEV = $(MAKE) -f $(HOME)/makefile.dev
CHPAT = $(HOME)/bin/chpat
RSYNC = rsync -av
Uploadee = csail
SCMOPTS = udscm[45].opt scm[45].opt

# OS-X 10.6, but harmless for other OS.
SETARCH = env DYLD_NO_PIE=1
# Fedora-Core-1
#SETARCH = setarch i386

#CC = gcc
#CFLAGS = -g
#LIBS =
#LD = $(CC) -g
LD = $(CC)

# VERSION is defined in "patchlvl.h"
# RELEASE is for RPMs
RELEASE = 1

intro:	config.status
	@echo
	@echo "This is the scm $(VERSION) distribution.  Read \"scm.info\""
	@echo "to learn how to build and install SCM.  Or browse"
	@echo "      http://people.csail.mit.edu/jaffer/SCM"
	@echo

# ./configure --distdir=${HOME}/dist/ --snapdir=${HOME}/pub/ --htmldir=${HOME}/public_html/ --pdfdir=${HOME}/public_html/

config.status:
	./configure
Makefile: config.status
include config.status

libscmdir = $(libdir)scm/
windistdir = /c/Voluntocracy/dist/
rpm_prefix = $(HOME)/rpmbuild/

# This should be moved to "config.status"
x11incdir=/usr/include/

# directory where COPYING and InitXXX.scm reside.
#IMPLPATH = `pwd`/
IMPLPATH=$(srcdir)
include patchlvl.h
IMPLINIT = $(IMPLPATH)Init$(VERSION).scm

# If pathname where InitXXX.scm resides is not known in advance then
# SCM_INIT_PATH is the environment variable whose value is the
# pathname where InitXXX.scm resides.

hfiles = scm.h scmfig.h setjump.h patchlvl.h continue.h
cfiles = scmmain.c scm.c time.c repl.c ioext.c scl.c sys.c eval.c	\
	subr.c sc2.c unif.c rgx.c crs.c dynl.c record.c posix.c socket.c\
	unix.c rope.c ramap.c gsubr.c edline.c continue.c	\
	findexec.c script.c debug.c byte.c bytenumb.c differ.c
ufiles = pre-crt0.c ecrt0.c gmalloc.c unexec.c unexelf.c unexhp9k800.c	\
	unexsunos4.c unexalpha.c unexsgi.c unexmacosx.c			\
	macosx-config.h lastfile.c
#	cxux-crt0.s ecrt0.c gmalloc.c pre-crt0.c unexaix.c unexalpha.c \
#	unexapollo.c unexconvex.c unexec.c unexelf.c unexelf1.c \
#	unexencap.c unexenix.c unexfx2800.c unexhp9k800.c unexmips.c \
#	unexnext.c unexnt.c unexsgi.c unexsni.c unexsunos4.c
ofiles = scm.o time.o repl.o scl.o sys.o eval.o subr.o unif.o rope.o \
	continue.o findexec.o script.o debug.o
# continue-ia64.o
ifiles = Init$(VERSION).scm Transcen.scm Link.scm Macro.scm Macexp.scm \
	Tscript.scm compile.scm Iedline.scm Idiffer.scm
hobfiles = hobbit.scm scmhob.scm scmhob.h
turfiles = turtlegr.c turtle grtest.scm
xafiles = xatoms.scm x11.scm xevent.scm keysymdef.scm
xfiles = x.c x.h xgen.scm xevent.h inc2scm $(xafiles)

tfiles = r4rstest.scm example.scm pi.scm pi.c split.scm bench.scm \
	syntest2.scm syntest1.scm
texifiles = scm.texi fdl.texi indexes.texi platform.txi features.txi
dfiles = ANNOUNCE README COPYING COPYING.LESSER scm.1 scm.doc QUICKREF \
	$(texifiles) scm.info Xlibscm.info Xlibscm.texi \
	hobbit.info hobbit.texi
mfiles = configure Makefile build.scm build build.bat requires.scm \
	.gdbinit mkimpcat.scm disarm.scm scm.spec scm.nsi
sfiles = setjump.mar setjump.s ugsetjump.s continue-ia64.S \
	 get-contoffset-ia64.c
wbfiles = wbtab.scm rwb-isam.scm
catfiles = implcat slibcat
afiles = $(dfiles) ChangeLog $(cfiles) $(hfiles) $(ifiles) $(tfiles)	\
	$(mfiles) $(hobfiles) $(sfiles) $(ufiles) $(xfiles)		\
	version.txi # $(wbfiles) $(turfiles)

lsdfiles = $(ifiles) $(hobfiles) COPYING COPYING.LESSER r4rstest.scm	\
	build.scm mkimpcat.scm patchlvl.h
#*.sl

ctagfiles = $(hfiles) $(cfiles) $(xfiles)
tagfiles = $(ctagfiles) $(ifiles) $(sfiles) $(mfiles)	\
	Xlibscm.texi hobbit.texi build hobbit.scm
#	# $(ufiles) ChangeLog $(dfiles)

installdirs:
	mkdir -p $(DESTDIR)$(includedir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(libdir)
	mkdir -p $(DESTDIR)$(libscmdir)
	mkdir -p $(DESTDIR)$(mandir)man1/
	mkdir -p $(DESTDIR)$(infodir)
	mkdir -p $(DESTDIR)$(pdfdir)
	mkdir -p $(DESTDIR)$(dvidir)

platform.txi: build.scm
	$(MAKE) $(SCMLIT)
	$(SCMLIT) -r database-browse -l build.scm \
	-e "(browse build 'platform)" > platform.txi
features.txi: build build.scm
	$(MAKE) $(SCMLIT)
	$(SCMLIT) -l build -e"(make-features-txi)"

scm.dvi: $(texifiles) Makefile
	$(TEXI2DVI) -b -c $<
Xlibscm.dvi: Xlibscm.texi version.txi
	$(TEXI2DVI) -b -c $<
hobbit.dvi: hobbit.texi version.txi
	$(TEXI2DVI) -b -c $<
dvi:	scm.dvi Xlibscm.dvi hobbit.dvi
xdvi:	scm.dvi
	xdvi $<
Xdvi:	Xlibscm.dvi
	xdvi $<
hobdvi:	hobbit.dvi
	xdvi $<
install-dvi: scm.dvi Xlibscm.dvi hobbit.dvi
	$(INSTALL_DATA) $< Xlibscm.dvi hobbit.dvi $(DESTDIR)$(dvidir)

scm.pdf: $(texifiles)
	$(TEXI2PDF) -b -c $<
Xlibscm.pdf: Xlibscm.texi version.txi
	$(TEXI2PDF) -b -c $<
hobbit.pdf: hobbit.texi version.txi
	$(TEXI2PDF) -b -c $<
pdf:	scm.pdf Xlibscm.pdf hobbit.pdf
xpdf:	scm.pdf
	$(VIEWPDF) $<
Xpdf:	Xlibscm.pdf
	$(VIEWPDF) $<
hobpdf:	hobbit.pdf
	$(VIEWPDF) $<
install-pdf: scm.pdf Xlibscm.pdf hobbit.pdf
	$(INSTALL_DATA) $< Xlibscm.pdf hobbit.pdf $(DESTDIR)$(pdfdir)

html/scm: $(texifiles)
	mkdir -p html
	rm -rf html/scm
	$(MAKEINFO) --html $< -o html/scm  --split=section
	if type icoize>/dev/null; then icoize ../Logo/SCM.ico html/scm/*.html; fi
$(DESTDIR)$(htmldir)scm: html/scm
	-rm -rf $(DESTDIR)$(htmldir)scm
	mkdir -p $(DESTDIR)$(htmldir)scm
	$(INSTALL_DATA) html/scm/*.html $(DESTDIR)$(htmldir)scm

html/Xlibscm: Xlibscm.texi version.txi
	mkdir -p html
	rm -rf html/Xlibscm
	$(MAKEINFO) --html $< -o html/Xlibscm --split=section --no-node-files
	if type icoize>/dev/null; then icoize ../Logo/SCM.ico html/Xlibscm/*.html; fi
$(DESTDIR)$(htmldir)Xlibscm: html/Xlibscm
	-rm -rf $(DESTDIR)$(htmldir)Xlibscm
	mkdir -p $(DESTDIR)$(htmldir)Xlibscm
	$(INSTALL_DATA) html/Xlibscm/*.html $(DESTDIR)$(htmldir)Xlibscm

html/hobbit: hobbit.texi version.txi
	mkdir -p html
	rm -rf html/hobbit
	$(MAKEINFO) --html $< -o html/hobbit --split=section
	if type icoize>/dev/null; then icoize ../Logo/SCM.ico html/hobbit/*.html; fi
$(DESTDIR)$(htmldir)hobbit: html/hobbit
	-rm -rf $(DESTDIR)$(htmldir)hobbit
	mkdir -p $(DESTDIR)$(htmldir)hobbit
	$(INSTALL_DATA) html/hobbit/*.html $(DESTDIR)$(htmldir)hobbit

html: html/scm html/Xlibscm html/hobbit

install-html: $(DESTDIR)$(htmldir)scm \
	$(DESTDIR)$(htmldir)Xlibscm \
	$(DESTDIR)$(htmldir)hobbit


scm-$(VERSION).info: $(texifiles)
	$(MAKEINFO) $< --no-split -o $@
scm.info: scm-$(VERSION).info
	cp $< $@
$(DESTDIR)$(infodir)scm.info: scm.info installdirs
	$(INSTALL_DATA) -p $< $@
	-rm -f $(DESTDIR)$(infodir)scm.info.gz
	$(POST_INSTALL)    # Post-install commands follow.
	-$(INSTALL_INFO) $@ $(DESTDIR)$(infodir)dir

Xlibscm.info: Xlibscm.texi version.txi
	$(MAKEINFO) $< --no-split -o $@
$(DESTDIR)$(infodir)Xlibscm.info: Xlibscm.info installdirs
	$(INSTALL_DATA) $< $@
	-rm -f $(DESTDIR)$(infodir)Xlibscm.info*.gz
	$(POST_INSTALL)    # Post-install commands follow.
	-$(INSTALL_INFO) $@ $(DESTDIR)$(infodir)dir

hobbit.info: hobbit.texi version.txi
	$(MAKEINFO) $< --no-split -o hobbit.info
$(DESTDIR)$(infodir)hobbit.info: hobbit.info installdirs
	$(INSTALL_DATA) $< $@
	-rm -f $(DESTDIR)$(infodir)hobbit.info*.gz
	$(POST_INSTALL)    # Post-install commands follow.
	-$(INSTALL_INFO) $@ $(DESTDIR)$(infodir)dir

install-info: $(DESTDIR)$(infodir)scm.info \
	  $(DESTDIR)$(infodir)Xlibscm.info \
	  $(DESTDIR)$(infodir)hobbit.info
info:	install-info

$(DESTDIR)$(infodir)scm.info.gz: $(DESTDIR)$(infodir)scm.info
	gzip -f $<
$(DESTDIR)$(infodir)Xlibscm.info.gz: $(DESTDIR)$(infodir)Xlibscm.info
	gzip -f $<
$(DESTDIR)$(infodir)hobbit.info.gz: $(DESTDIR)$(infodir)hobbit.info
	gzip -f $<
install-infoz: $(DESTDIR)$(infodir)scm.info.gz \
	  $(DESTDIR)$(infodir)Xlibscm.info.gz \
	  $(DESTDIR)$(infodir)hobbit.info.gz
infoz:	install-infoz

scm.doc: scm.1
	nroff -man $< | ul -tunknown >$@

# configure.usage: configure
# 	$(srcdir)configure --help >$@ 2>&1

README:	build build.scm scm.info
	$(SCMEXE) -bl build -e"(make-readme)"

docs: README scm.doc install-html install-pdf install-dvi install-infoz

alld5: udscm5.opt $(SCMLIT)
	if grep -ie dynamic-linking udscm5.opt>/dev/null && ! $(MAKE) dlls; \
	then \
	  if sed "s/dynamic-linking//g" < udscm5.opt > tmp.opt; then \
	  mv -f tmp.opt udscm5.opt; fi; \
	  if sed "s/dynamic-linking//g" < scm5.opt > tmp.opt; then \
	  mv -f tmp.opt scm5.opt; fi \
	fi
	if ! $(MAKE) dscm5; then $(MAKE) scm5; fi

all5: scm5.opt $(SCMLIT)
	if grep -ie dynamic-linking scm5.opt>/dev/null && ! $(MAKE) dlls; \
	then \
	  if sed "s/dynamic-linking//g" < scm5.opt > tmp.opt; then \
	  mv -f tmp.opt scm5.opt; fi \
	fi
	$(MAKE) scm5

all:
	if [ -f udscm5.opt -o ! -f scm5.opt ]; then $(MAKE) alld5; \
	else $(MAKE) all5; fi

#	$(MAKE) wbscm.so

require.scm:
	cp -p requires.scm require.scm

# SCMLIT -- Make this first!
$(SCMLIT):	$(ofiles) scmmain.o require.scm Makefile
	$(LD) -o scmlit $(ofiles) scmmain.o $(LIBS)
	$(MAKE) checklit
scmflags.h:	scmflags
scmflags:
	echo "#ifndef IMPLINIT" > newflags.h
	echo "#define IMPLINIT \"$(IMPLINIT)\"" >> newflags.h
	echo "#endif" >> newflags.h
	echo "#define CHEAP_CONTINUATIONS" >> newflags.h
	echo "#define CAUTIOUS" >> newflags.h
	-if (cmp -s newflags.h scmflags.h) then rm newflags.h; \
		 else mv newflags.h scmflags.h; fi
.c.o:
	$(CC) -c $(CFLAGS) $< -o $@
scm.o:	scm.c scm.h scmfig.h scmflags.h patchlvl.h
scmmain.o:	scmmain.c scm.h scmfig.h scmflags.h patchlvl.h
scl.o:	scl.c scm.h scmfig.h scmflags.h
eval.o:	eval.c scm.h scmfig.h scmflags.h setjump.h
debug.o: debug.c scm.h scmfig.h scmflags.h setjump.h
unif.o:	unif.c scm.h scmfig.h scmflags.h
#ramap.o:	ramap.c scm.h scmfig.h scmflags.h
repl.o:	repl.c scm.h scmfig.h scmflags.h setjump.h
sys.o:	sys.c scm.h scmfig.h scmflags.h setjump.h
time.o:	time.c scm.h scmfig.h scmflags.h
subr.o:	subr.c scm.h scmfig.h scmflags.h
rope.o:	rope.c scm.h scmfig.h scmflags.h
continue.o: continue.c continue.h setjump.h scm.h scmfig.h scmflags.h
continue-ia64.o: continue-ia64.S get-contoffset-ia64.c
	gcc -o get-contoffset-ia64 get-contoffset-ia64.c
	./get-contoffset-ia64 contoffset-ia64.S
	gcc -c -o continue-ia64.o continue-ia64.S

# Simple build with bignums for running JACAL
scm:	$(SCMLIT)
	$(BUILD) -s $(IMPLPATH) -F cautious bignums arrays # i/o-extensions
	$(MAKE) check

# R4RS interpreter (not dumpable)
scm4.opt:
	echo "-F cautious bignums arrays inexact" > scm4.opt
	echo "-F engineering-notation dynamic-linking" >> scm4.opt
#	if type gcc; then echo "--compiler-options=\"-fno-guess-branch-probability\"" >> scm4.opt; fi
scm4:	$(cfiles) $(hfiles) build.scm build scm4.opt
	$(BUILD) -f scm4.opt -o scm -s $(IMPLPATH)
	-rm $(ofiles) scmmain.o
	$(MAKE) check

# R5RS interpreter (not dumpable)
scm5.opt:
	echo "-F cautious bignums arrays inexact" > scm5.opt
	echo "-F engineering-notation dynamic-linking" >> scm5.opt
	echo "-F macro" >> scm5.opt
	echo "--compiler-options=\"-O1\"" >> scm5.opt

=== debian/changelog ===
scm (5f4-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    (Closes: #1097858)

 -- Adrian Bunk <bunk@debian.org>  Sat, 25 Oct 2025 18:54:34 +0300

scm (5f4-3) unstable; urgency=medium

  * define-scm-llong-for-64-bit-archs.patch: Fix builds on riscv64 as well

 -- Gwen Weinholt <weinholt@debian.org>  Mon, 13 Jan 2025 00:16:35 +0100

scm (5f4-2) unstable; urgency=medium

  * define-scm-llong-for-64-bit-archs.patch: Fix building on most 64-bit
    archs (hopefully).

 -- Gwen Weinholt <weinholt@debian.org>  Sun, 12 Jan 2025 23:04:32 +0100

scm (5f4-1) unstable; urgency=medium

  [ Gwen Weinholt ]
  * New upstream version 5f4
  * do-not-use-catalog-expand-path.patch: Support for slib 3b6.
  * debian/patches: Rebase patches.
  * debian/patches/fix-numerous-compilation-errors.patch: Fix various
    compiler warnings (Closes: #1081101)
  * debian/patches/fix-i386-build.patch: Fix i386 compilation.
    Thanks to Jens Thiele for the patch
  * debian/patches/fix-arm-builds.patch: Fix armel, armhf builds

  [ xiaojuan zhai ]
  * Add support for loong64 (Closes: #1050764)

 -- Gwen Weinholt <weinholt@debian.org>  Sat, 11 Jan 2025 22:07:34 +0100

scm (5f3-6) unstable; urgency=medium

  * Fix fix-implicit-decl-libc.patch for mips64el builds

 -- Gwen Weinholt <weinholt@debian.org>  Sat, 04 May 2024 16:12:22 +0200

scm (5f3-5) unstable; urgency=medium

  * Fix build with opaque ncurses.
    Thanks to Sven Joachim for the patch (Closes: #1057602)
  * Fix implicit declarations of some libc functions
  * Fix implicit declarations of some init_*() functions
  * debian: Fix my name

 -- Gwen Weinholt <weinholt@debian.org>  Sat, 20 Apr 2024 12:25:18 +0200

scm (5f3-4) unstable; urgency=medium

  * Team upload.
  * Fix ftbfs on mipsel. Closes: #1029122
  * Use libncurses-dev instead of libncurses5-dev

 -- Bo YU <tsu.yubo@gmail.com>  Wed, 18 Jan 2023 12:34:18 +0800

scm (5f3-3) unstable; urgency=medium

  * Team upload.

  * Fix ftbfs on riscv64, s390x, mips64el. Closes: #1026844, #387087

 -- Bo YU <tsu.yubo@gmail.com>  Sun, 15 Jan 2023 09:58:02 +0800

scm (5f3-2) unstable; urgency=medium

  Team upload.

  [ Göran Weinholt ]
  * use-compiler-flags.patch: Pass through compilation flags to gcc
  * debian/patches/disable-bigrecy.patch: Disable bigrecy() again
    (Closes: #1024882)
  * debian/rules: Disable C optimizations to work around a test failure
  * debian/control: Add myself to uploaders

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster
  * Update standards version to 4.6.1, no changes needed.

 -- Göran Weinholt <weinholt@debian.org>  Sun, 18 Dec 2022 14:15:57 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Debian Scheme Dream Team <debian-scheme@lists.debian.org>
 Uploaders: Bryan Newbold <bnewbold@robocracy.org>,
-	   Barak A. Pearlmutter <bap@debian.org>
+	   Barak A. Pearlmutter <bap@debian.org>,
+	   Gwen Weinholt <weinholt@debian.org>
 Build-Depends: debhelper-compat (= 13),
-		slib (>> 3b1),
-		libncurses5-dev, libreadline-dev,
+		slib,
+		libncurses-dev, libreadline-dev,
 		texinfo,
 		libx11-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://people.csail.mit.edu/jaffer/SCM.html
 Vcs-Git: https://salsa.debian.org/scheme-team/scm.git
@@ -17,7 +18,7 @@
 
 Package: scm
 Architecture: any
-Depends: slib (>> 3b1), ${shlibs:Depends}, ${misc:Depends}
+Depends: slib, ${shlibs:Depends}, ${misc:Depends}
 Suggests: r5rs-doc
 Description: Scheme language interpreter
  SCM conforms to the R5RS (Revised^5 Report on the Algorithmic Language Scheme)
@@ -29,7 +30,7 @@
 Package: libscm-dev
 Architecture: any
 Section: libdevel
-Depends: scm (= ${binary:Version}), slib (>> 3b1), ${misc:Depends}
+Depends: scm (= ${binary:Version}), slib, ${misc:Depends}
 Suggests: r5rs-doc
 Description: Embeddable library for SCM Scheme language interpreter
  Compact static library containing the SCM interpreter and an API making it

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 # package maintainers to append CFLAGS
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
+
+# Upstream builds without optimization and tests fail with even -O1.
+CFLAGS += -O0 -std=gnu17
 
 %:
 	dh $@

=== debian/watch ===
# watch control file for uscan
# See uscan(1) for format

version=4

https://ftp.gnu.org/gnu/@PACKAGE@/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
